﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Tampilan_data_accel_dan_gyro
{
    public partial class Form1 : Form
    {
        int acc_valX1, acc_valY1, acc_valZ1, acc_valX2, acc_valY2, acc_valZ2;
        int acc_signX, acc_signY, acc_signZ;
        int gyro_valX1, gyro_valY1, gyro_valZ1, gyro_valX2, gyro_valY2, gyro_valZ2;
        int save_gyroX, save_gyroY, save_gyroZ;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            serialPort1.Open();
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                if (serialPort1.ReadByte() == 'a')
                {
                    gyro_valX1 = serialPort1.ReadByte();
                    gyro_valX2 = serialPort1.ReadByte();
                    gyro_valY1 = serialPort1.ReadByte();
                    gyro_valY2 = serialPort1.ReadByte();
                    gyro_valZ1 = serialPort1.ReadByte();
                    gyro_valZ2 = serialPort1.ReadByte();
                    acc_signX = serialPort1.ReadByte();
                    acc_valX1 = serialPort1.ReadByte();
                    acc_valX2 = serialPort1.ReadByte();
                    acc_signY = serialPort1.ReadByte();
                    acc_valY1 = serialPort1.ReadByte();
                    acc_valY2 = serialPort1.ReadByte();
                    acc_signZ = serialPort1.ReadByte();
                    acc_valZ1 = serialPort1.ReadByte();
                    acc_valZ2 = serialPort1.ReadByte();
                    this.BeginInvoke(new EventHandler(type));
                }
            }
            catch (System.TimeoutException)
            {
                MessageBox.Show("data error");
            }
        }

        void type(object s, EventArgs e)
        {
            textBox1.Text = Convert.ToString(Convert.ToChar(acc_signX)) + Convert.ToString(acc_valX1 * 256 + acc_valX2);
            textBox2.Text = Convert.ToString(Convert.ToChar(acc_signY)) + Convert.ToString(acc_valY1 * 256 + acc_valY2);
            textBox3.Text = Convert.ToString(Convert.ToChar(acc_signZ)) + Convert.ToString(acc_valZ1 * 256 + acc_valZ2);

            save_gyroX = gyro_valX1 << 8 | gyro_valX2;
            save_gyroY = gyro_valY1 << 8 | gyro_valY2;
            save_gyroZ = gyro_valZ1 << 8 | gyro_valZ2;

            if (save_gyroX > 32768) save_gyroX = save_gyroX - 65536;
            if (save_gyroY > 32768) save_gyroY = save_gyroY - 65536;
            if (save_gyroZ > 32768) save_gyroZ = save_gyroZ - 65536;

            textBox4.Text = Convert.ToString(save_gyroX);
            textBox5.Text = Convert.ToString(save_gyroY);
            textBox6.Text = Convert.ToString(save_gyroZ);
        }

        private void button2_Click(object sender, EventArgs e)
        {
             serialPort1.Close();
             Application.Exit();
        }
    }
}
