#ifndef SettingAccelI2C_H
#define SettingAccelI2C_H

#include <arduino.h>

void setOffsetValueAccel(unsigned char address,unsigned int value);
void writeRegisterValueByteAccel(unsigned char address,unsigned char value);
void setModeControl(unsigned char value);
unsigned char readRegisterValueByteAccel(unsigned char address);
unsigned int readRegisterValueWordAccel(unsigned char address);
void TenBitTwoComplementToSignAndValue(unsigned int input,unsigned char* sign, unsigned int* value);
unsigned int SignAndValueToTwoComplementOffset(unsigned char sign,unsigned int value);

void movingAverage(int dataX, int dataY, int dataZ);
void average(int dataX, int dataY, int dataZ);

void SerialAccel1(int signx, int accelx, int signy, int accely, int signz, int accelz);
void SerialAccel2(int signx, int accelx, int signy, int accely, int signz, int accelz);

void I2CAccel_init();

#endif